<template>
  <div class="settings">
    <div class="settings-title">Танзими <b>барнома</b></div>

    <!-- <button type="button" class="form-btn">Специализации</button>
    <button type="button" class="form-btn">Категории НМО/НПР</button>
    <button type="button" class="form-btn">Мероприятия НМО/НПР</button> -->

    <div class="settings-item">
      <p>Ихтисосҳо:</p>
      <form @submit.prevent="addSpecialization()">
        <div>
          <span v-if="isAlreadySpecialization" style="color: #ff5c5c">
            * Ин ихтисос аллакай вуҷуд дорад
          </span>
          <span>Номи ихтисос</span>
          <Input
            class="account-item"
            v-model="specialization"
            required
            placeholder="Масалан: гинеколог"
          />
        </div>
        <button type="submit" class="curve-btn">
          <div>Илова кардан (кунед)</div>
        </button>
      </form>
      <div class="settings-item__block" v-if="access">
        <div
          v-for="(specialization, index) in specializations_list.data"
          class="settings-item__wrapper"
        >
          <span>{{ index + 1 }}.</span>
          <label>
            <b> {{ specialization.label }} </b>
          </label>
          <hr />
          <button
            type="button"
            style="color: red"
            @click="removeSpecialization(specialization)"
          >
            Тоза кардан
          </button>
          <!-- <button type="button" @click="changeSpecialization(specialization)">
            изменить
          </button> -->
        </div>
      </div>
    </div>

    <div class="settings-item" v-if="access">
      <p>Гурӯҳҳо барои ТМТ/РМК:</p>
      <form @submit.prevent="addCategory()">
        <div>
          <span v-if="isAlreadyCategory" style="color: #ff5c5c">
            * Ин гурӯҳ аллакай вуҷуд дорад
          </span>
          <span>Номи чорабиниҳо</span>
          <Input
            class="account-item"
            v-model="category.name"
            required
            placeholder="Масалан: чорабиниҳои ғайрирасмии ТМТ/РМК"
          />
        </div>
        <div>
          <span>Барои кадом ихтисос ?</span>
          <div>
            <Select
              :data="specializations_list.data"
              v-model="category.specializations"
              multiple
              required
            />
          </div>
        </div>
        <div>
          <span> Шумораи фоизи камтарин аз соатҳои кредитии умумӣ </span>
          <Input
            class="account-item"
            v-model="category.min"
            required
            placeholder="масалан: 15"
            type="number"
          />
        </div>
        <div>
          <span> Шумораи фоизи максималӣ аз соатҳои кредитии умумӣ </span>
          <Input
            class="account-item"
            v-model="category.max"
            required
            placeholder="масалан: 65"
            type="number"
          />
        </div>

        <button type="submit" class="curve-btn">
          <div>Илова кардан (кунед)</div>
        </button>
      </form>
      <div class="settings-item__block" v-if="categories_list.length > 0">
        <div
          v-for="(category, index) in categories_list"
          class="settings-item__wrapper"
        >
          <span>{{ index + 1 }}.</span>
          <label>
            <b> {{ category.name }} </b> <br />
            <span v-for="item in category.specializations" :key="item">
              - Барои - {{ item }}
              <br />
            </span>
            <!-- - {{ category.specializations }} -->
          </label>
          <hr />
          <button
            type="button"
            style="color: red"
            @click="
              removeCategory({
                name: category.name,
                specializations: category.specializations,
              })
            "
          >
            Тоза кунед
          </button>
        </div>
      </div>
    </div>

    <div class="settings-item" v-if="access">
      <p>Чорабиниҳои РМК/ ТМТ:</p>
      <form @submit.prevent="addEvent()">
        <div>
          <span v-if="isAlreadyEvent" style="color: #ff5c5c">
            * Чорабинии мазкур аллакай мавҷуд аст
          </span>
          <span>Номи чорабинӣ </span>
          <Input
            class="account-item"
            v-model="event.name"
            required
            placeholder="Масалан: омӯзишӣ  фосилавӣ дар тибби оилавӣ "
          />
        </div>
        <div>
          <span>Барои кадом гурӯҳ? </span>
          <Select
            multiple
            :data="
              categories_list.map((el) => {
                return {
                  label: (el.name + ' (' + el.specializations + ')').replace(
                    ',',
                    '; '
                  ),
                  value: (el.name + ' (' + el.specializations + ')').replace(
                    ',',
                    '; '
                  ),
                };
              })
            "
            v-model="event.categories"
            required
          />
        </div>
        <div>
          <span>Намуди чорабиниҳоро интихоб намоед </span>
          <Select single :data="types_list" v-model="event.type" required />
        </div>
        <div></div>
        <button type="submit" class="curve-btn">
          <div>Илова кардан (кунед)</div>
        </button>
      </form>
      <div class="settings-item__block" v-if="events_list.length > 0">
        <div
          v-for="(event, index) in events_list"
          class="settings-item__wrapper"
        >
          <span>{{ index + 1 }}.</span>
          <label>
            <b> {{ event.name }} </b> <br />
            - {{ event.type }} <br />
            <span v-for="item in event.categories" :key="item">
              - Гурӯҳҳи - {{ item }}
              <br />
            </span>
            <span v-for="item in event.specializations" :key="item">
              - Барои - {{ item }}
              <br />
            </span>
          </label>
          <hr />
          <button style="color: red" type="button" @click="removeEvent(event)">
            Тоза кунед
          </button>
        </div>
      </div>
    </div>

    <Confirm />
  </div>
</template>

<script>
const TYPES = ["Чорабиниҳо", "Такмили ихтисос", "Маводҳо"];
export default {
  layout: "profile",
  middleware: "auth",
  data() {
    return {
      access: false,
      specialization: "",
      category: {
        name: "",
        specializations: [],
        max: "",
        min: "",
      },
      event: {
        name: "",
        type: "",
        categories: [],
        specializations: [],
      },

      specializations_list: [],
      categories_list: [],
      events_list: [],
      types_list: TYPES,

      isAlreadySpecialization: false,
      isAlreadyCategory: false,
      isAlreadyEvent: false,

      // Для того чтобы обновить селекты
      is_categories_list_changed: 1,

      warningModal: false,
    };
  },
  fetchOnServer: false,
  fetch() {
    this.getSettings();
  },
  methods: {
    addSpecialization() {
      const list = new Map();
      this.specializations_list.data.map((el) => {
        return list.set(el.value.toLowerCase());
      });
      if (list.has(this.specialization.toLowerCase())) {
        this.isAlreadySpecialization = true;
      } else {
        this.$axios
          .$post("/settings/addSpecialization", {
            name: this.specialization,
          })
          .then(() => {
            this.isAlreadySpecialization = false;
            this.specializations_list.data.push({
              value: this.specialization,
              label: this.specialization,
            });
            this.specialization = "";
            this.access = true;
          })
          .catch((error) => {
            console.log(error);
          });
      }
    },

    removeSpecialization(specialization) {
      if (specialization === "Омӯзгор") {
        return;
      } else {
        this.$confirm({
          title: "Огоҳӣ!",
          message: `Шумо мутмаин ҳастед, ки мехоҳед "${specialization}" -ро тоза кунед? <br /><br /> Бо тоза кардани ин банд, шумо ҷузъиёти алоқамандро бо ин банд нест мекунед!`,
          button: {
            yes: "Тоза кардан",
            no: "Баргаштан ",
          },
          callback: (confirm) => {
            if (confirm) {
              this.$axios
                .$post("/settings/removeSpecialization", specialization.value)
                .then(() => {
                  this.specializations_list.data =
                    this.specializations_list.data.filter(
                      (el) => el.value !== specialization.value
                    );
                  this.categories_list = this.categories_list.filter(
                    (el) => !el.specializations.includes(specialization.value)
                  );
                  this.events_list = this.events_list.filter(
                    (el) => !el.specializations.includes(specialization.value)
                  );
                })
                .catch((error) => {
                  console.log(error);
                });
            }
          },
        });
      }
    },

    changeSpecialization(specialization) {},

    addCategory() {
      const list_name = new Set();
      const list_specialization = new Set();
      this.categories_list.map((el) => {
        list_name.add(el.name.toLowerCase());
        list_specialization.add(el.specialization);
      });
      if (
        list_name.has(this.category.name.toLowerCase()) &&
        list_specialization.has(this.category.specializations)
      ) {
        this.isAlreadyCategory = true;
      } else {
        this.$axios
          .$post("/settings/addCategory", this.category)
          .then(() => {
            this.isAlreadyCategory = false;
            this.categories_list.push(this.category);
            this.is_categories_list_changed++;
            this.category = {
              name: "",
              specializations: [],
              max: "",
              min: "",
            };
          })
          .catch((error) => {
            console.log(error);
          });
      }
    },

    removeCategory(category) {
      this.$confirm({
        title: "Огоҳӣ!",
        message: `Шумо мутмаин ҳастед, ки мехоҳед "${category.name}" -ро тоза намоед? <br /><br /> Бо тоза кардани ин банд, шумо ҷузъиёти алоқамандро бо ин банд нест мекунед!`,
        button: {
          yes: "Тоза кардан",
          no: "Баргаштан",
        },
        callback: (confirm) => {
          if (confirm) {
            this.$axios
              .$post("/settings/removeCategory", category)
              .then(() => {
                this.categories_list = this.categories_list.filter(
                  (el) =>
                    JSON.stringify(category) !==
                    JSON.stringify({
                      name: el.name,
                      specializations: el.specializations,
                    })
                );
                this.events_list = this.events_list.filter(
                  (el) => el.category !== category.name
                );
                this.is_categories_list_changed++;
              })
              .catch((error) => {
                console.log(error);
              });
          }
        },
      });
    },

    addEvent() {
      let new_event = JSON.parse(JSON.stringify(this.event));
      new_event.specializations = new_event.categories.map((el) => {
        return el
          .substring(el.indexOf(" (") + 2, el.lastIndexOf(")"))
          .split("; ");
      });
      new_event.specializations = new_event.specializations[0];
      new_event.categories = new_event.categories.map((el) =>
        el.substring(0, el.lastIndexOf(" ("))
      );

      let isSimilar = false;
      this.events_list.map((el) => {
        if (JSON.stringify(new_event) === JSON.stringify(el)) isSimilar = true;
      });
      if (isSimilar) {
        this.isAlreadyEvent = true;
      } else {
        this.isAlreadyEvent = false;
        this.$axios
          .$post("/settings/addEvent", new_event)
          .then(() => {
            this.isAlreadyEvent = false;
            this.events_list.push(new_event);
            this.event = {
              name: "",
              type: "",
              categories: [],
              specializations: [],
            };
          })
          .catch((error) => {
            console.log(error);
          });
      }
    },
    removeEvent(event) {
      this.$confirm({
        title: "Огоҳӣ!",
        message: `Шумо мутмаин ҳастед, ки мехоҳед "${event.name}" –ро тоза кунед? <br /><br /> Бо тоза кардани ин банд, шумо ҷузъиёти алоқамандро бо ин банд нест мекунед!`,
        button: {
          yes: "Тоза кардан",
          no: "Баргаштан",
        },
        callback: (confirm) => {
          if (confirm) {
            this.$axios
              .$post("/settings/removeEvent", event)
              .then(() => {
                this.events_list = this.events_list.filter(
                  (el) => JSON.stringify(event) !== JSON.stringify(el)
                );
              })
              .catch((error) => {
                console.log(error);
              });
          }
        },
      });
    },

    getSettings() {
      this.$axios
        .$get("/settings")
        .then((response) => {
          if (response.specializations_list[0].data.length > 0) {
            this.access = true;
          }
          this.specializations_list = response.specializations_list[0];
          this.categories_list = response.categories_list;
          this.events_list = response.events_list;
        })
        .catch((error) => {
          console.log(error);
        });
    },
  },
};
</script>

<style lang="scss" scoped>
.settings {
  min-height: 70vh;
  margin-left: 20px;
  padding: 20px;
  background-color: #fff;
  box-shadow: 1px 1.732px 10px 0 rgb(0 0 0 / 5%);
  width: 100%;
  @include less-than(tablet) {
    margin-left: 0px;
  }

  &-title {
    line-height: 1.3;
    font-size: 36px;

    b {
    }
  }

  &-item {
    border: 1px solid #e1e1e6;
    border-radius: 12px;
    padding: 20px;
    transition: all ease 0.3s;
    margin: 20px 0;
    @include less-than(laptop) {
      padding: 10px;
    }

    p {
      font-family: "Montserrat-Bold";
      margin-bottom: 10px;
      font-size: 18px;
    }
  }
  &-item__block {
    max-height: 300px;
    overflow: auto;
    padding: 10px;
    border: 1px solid #e1e1e6;
    border-radius: 12px;
    margin-top: 10px;
  }
  &-item__wrapper {
    margin-top: 10px;
    margin-bottom: 20px;
    display: grid;
    grid-template-columns: 5px auto 1fr auto;
    text-align: left;
    align-items: center;
    grid-gap: 15px;
    &:nth-last-child(1) {
      margin-bottom: 10px;
    }
    @include less-than(laptop) {
      padding-bottom: 10px;
      border-bottom: 1px solid #ccc;
      grid-template-columns: 2.5fr 1fr;
      span,
      hr {
        display: none;
      }
    }

    button {
      font-weight: 800;
      background: none;
      &:hover {
        color: #0c63e4;
      }
    }

    label,
    span {
      line-height: 1;
      b {
        font-family: "Montserrat-SemiBold";
      }
    }

    hr {
      border: none;
      border-bottom: 1px dashed #0c63e4;
    }
  }

  form {
    padding: 10px 0;
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    text-align: left;
    grid-gap: 20px;
    align-items: flex-end;
    @include less-than(tablet) {
      grid-template-columns: repeat(1, 1fr);
      grid-gap: 20px;
    }
    span {
      display: block;
      margin-bottom: 5px;
      line-height: 1;
    }
  }
}
</style>
